/* -*- mode: c++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/*
 Copyright (C) 2015 Johannes Göttker-Schnetmann
 Copyright (C) 2015 Klaus Spanderen

 This file is part of QuantLib, a free-software/open-source library
 for financial quantitative analysts and developers - http://quantlib.org/

 QuantLib is free software: you can redistribute it and/or modify it
 under the terms of the QuantLib license.  You should have received a
 copy of the license along with this program; if not, please email
 <quantlib-dev@lists.sf.net>. The license is also available online at
 <http://quantlib.org/license.shtml>.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the license for more details.
*/

#ifndef quantlib_test_risk_neutral_density_calculator_hpp
#define quantlib_test_risk_neutral_density_calculator_hpp

#include <boost/test/unit_test.hpp>
#include "speedlevel.hpp"

/* remember to document new and/or updated tests in the Doxygen
   comment block of the corresponding class */

class RiskNeutralDensityCalculatorTest {
  public:
    static void testDensityAgainstOptionPrices();
    static void testBSMagainstHestonRND();
    static void testLocalVolatilityRND();
    static void testSquareRootProcessRND();
    static void testMassAtZeroCEVProcessRND();
    static void testCEVCDF();
    static void testBlackScholesWithSkew();
    static boost::unit_test_framework::test_suite* experimental(SpeedLevel);
};

#endif
